Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 15242)
@@ -21,17 +21,33 @@
 
 using System;
+using System.Collections;
 using System.Collections.Generic;
+using System.Linq;
 using System.Windows.Forms;
 using HeuristicLab.Core.Views;
+using HeuristicLab.Data;
 using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.DataPreprocessing.Views {
-
   [View("Statistics View")]
   [Content(typeof(StatisticsContent), true)]
   public partial class StatisticsView : ItemView {
-
-    private List<List<string>> columnsRowsMatrix;
-    private readonly int COLUMNS = 12;
+    private bool horizontal = false;
+    private StringMatrix statisticsMatrix;
+    private static readonly string[] StatisticsNames = new[] {
+      "Type",
+      "Missing Values",
+      "Min",
+      "Max",
+      "Median",
+      "Average",
+      "Std. Deviation",
+      "Variance",
+      "25th Percentile",
+      "75th Percentile",
+      "Most Common Value",
+      "Num. diff. Values"
+    };
 
     public new StatisticsContent Content {
@@ -47,10 +63,12 @@
       base.OnContentChanged();
       if (Content == null) {
-        txtRows.Text = "";
-        txtColumns.Text = "";
-        txtNumericColumns.Text = "";
-        txtNominalColumns.Text = "";
-        txtMissingValuesTotal.Text = "";
-        dataGridView.Columns.Clear();
+        rowsTextBox.Text = string.Empty;
+        columnsTextBox.Text = string.Empty;
+        numericColumnsTextBox.Text = string.Empty;
+        nominalColumnsTextBox5.Text = string.Empty;
+        missingValuesTextBox.Text = string.Empty;
+        totalValuesTextBox.Text = string.Empty;
+        stringMatrixView.Content = null;
+        statisticsMatrix = null;
       } else {
         UpdateData();
@@ -58,81 +76,78 @@
     }
 
-    /// <summary>
-    /// Adds eventhandlers to the current instance.
-    /// </summary>
     protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
       Content.Changed += Content_Changed;
     }
 
-
-    /// <summary>
-    /// Removes the eventhandlers from the current instance.
-    /// </summary>
     protected override void DeregisterContentEvents() {
       Content.Changed -= Content_Changed;
-    }
-
-    private void UpdateData() {
-      var logic = Content.StatisticsLogic;
-      var rowCount = logic.GetRowCount();
-      txtRows.Text = rowCount.ToString();
-      txtColumns.Text = logic.GetColumnCount().ToString();
-      txtNumericColumns.Text = logic.GetNumericColumnCount().ToString();
-      txtNominalColumns.Text = logic.GetNominalColumnCount().ToString();
-      txtMissingValuesTotal.Text = logic.GetMissingValueCount().ToString();
-
-      columnsRowsMatrix = new List<List<string>>();
-      DataGridViewColumn[] columns = new DataGridViewColumn[COLUMNS];
-      for (int i = 0; i < COLUMNS; ++i) {
-        var column = new DataGridViewTextBoxColumn();
-        column.SortMode = DataGridViewColumnSortMode.Automatic;
-        column.FillWeight = 1;
-        columns[i] = column;
-      }
-
-      columns[0].HeaderCell.Value = "Type";
-      columns[1].HeaderCell.Value = "Missing Values";
-      columns[2].HeaderCell.Value = "Min";
-      columns[3].HeaderCell.Value = "Max";
-      columns[4].HeaderCell.Value = "Median";
-      columns[5].HeaderCell.Value = "Average";
-      columns[6].HeaderCell.Value = "std. Deviation";
-      columns[7].HeaderCell.Value = "Variance";
-      columns[8].HeaderCell.Value = "25th Percentile";
-      columns[9].HeaderCell.Value = "75th Percentile";
-      columns[10].HeaderCell.Value = "Most Common Value";
-      columns[11].HeaderCell.Value = "Num. diff. Values";
-
-      if (rowCount > 0) {
-        for (int i = 0; i < logic.GetColumnCount(); ++i) {
-          columnsRowsMatrix.Add(GetList(i));
-        }
-      }
-
-      dataGridView.Columns.Clear();
-      dataGridView.Columns.AddRange(columns);
-      dataGridView.RowCount = columnsRowsMatrix.Count;
-
-      for (int i = 0; i < columnsRowsMatrix.Count; ++i) {
-        dataGridView.Rows[i].HeaderCell.Value = logic.GetVariableName(i);
-      }
-
-      dataGridView.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.DisplayedCells);
-      dataGridView.AutoResizeRowHeadersWidth(DataGridViewRowHeadersWidthSizeMode.AutoSizeToDisplayedHeaders);
-      dataGridView.AllowUserToResizeColumns = true;
-    }
-
-    private List<string> GetList(int i) {
+      base.DeregisterContentEvents();
+    }
+
+    private void UpdateData(Dictionary<string, bool> oldVisibility = null) {
+      var logic = Content.StatisticsLogic;
+      rowsTextBox.Text = logic.GetRowCount().ToString();
+      columnsTextBox.Text = logic.GetColumnCount().ToString();
+      numericColumnsTextBox.Text = logic.GetNumericColumnCount().ToString();
+      nominalColumnsTextBox5.Text = logic.GetNominalColumnCount().ToString();
+      missingValuesTextBox.Text = logic.GetMissingValueCount().ToString();
+      totalValuesTextBox.Text = (logic.GetColumnCount() * logic.GetRowCount() - logic.GetMissingValueCount()).ToString();
+
+      var variableNames = Content.PreprocessingData.VariableNames.ToList();
+      if (horizontal)
+        statisticsMatrix = new StringMatrix(StatisticsNames.Length, Content.PreprocessingData.Columns) {
+          RowNames = StatisticsView.StatisticsNames,
+          ColumnNames = variableNames
+        };
+      else
+        statisticsMatrix = new StringMatrix(Content.PreprocessingData.Columns, StatisticsNames.Length) {
+          RowNames = variableNames,
+          ColumnNames = StatisticsView.StatisticsNames
+        };
+
+      for (int i = 0; i < logic.GetColumnCount(); i++) {
+        var data = GetStatistics(i);
+        for (int j = 0; j < data.Count; j++) {
+          if (horizontal)
+            statisticsMatrix[j, i] = data[j];
+          else
+            statisticsMatrix[i, j] = data[j];
+        }
+      }
+
+      stringMatrixView.Parent.SuspendRepaint();
+      stringMatrixView.Content = statisticsMatrix;
+
+      var grid = stringMatrixView.DataGridView;
+      int idx = 0;
+      var list = horizontal ? grid.Columns : grid.Rows as IList;
+      foreach (DataGridViewBand band in list) {
+        var variable = variableNames[idx++];
+        if (oldVisibility != null) {
+          band.Visible = !oldVisibility.ContainsKey(variable) || oldVisibility[variable];
+        }
+      }
+      if (horizontal)
+        stringMatrixView.UpdateColumnHeaders();
+      else
+        stringMatrixView.UpdateRowHeaders();
+
+      stringMatrixView.DataGridView.AutoResizeColumns();
+      stringMatrixView.Parent.ResumeRepaint(true);
+    }
+
+    private List<string> GetStatistics(int varIdx) {
       List<string> list;
       var logic = Content.StatisticsLogic;
-      if (logic.VariableHasType<double>(i)) {
-        list = GetDoubleColumns(i);
-      } else if (logic.VariableHasType<string>(i)) {
-        list = GetStringColumns(i);
-      } else if (logic.VariableHasType<DateTime>(i)) {
-        list = GetDateTimeColumns(i);
+      if (logic.VariableHasType<double>(varIdx)) {
+        list = GetDoubleColumns(varIdx);
+      } else if (logic.VariableHasType<string>(varIdx)) {
+        list = GetStringColumns(varIdx);
+      } else if (logic.VariableHasType<DateTime>(varIdx)) {
+        list = GetDateTimeColumns(varIdx);
       } else {
         list = new List<string>();
-        for (int j = 0; j < COLUMNS; ++j) {
+        for (int j = 0; j < StatisticsNames.Length; ++j) {
           list.Add("unknown column type");
         }
@@ -141,27 +156,27 @@
     }
 
-    private List<string> GetDoubleColumns(int columnIndex) {
+    private List<string> GetDoubleColumns(int statIdx) {
       var logic = Content.StatisticsLogic;
       return new List<string> {
-        logic.GetColumnTypeAsString(columnIndex),
-        logic.GetMissingValueCount(columnIndex).ToString(),
-        logic.GetMin<double>(columnIndex,double.NaN).ToString(),
-        logic.GetMax<double>(columnIndex,double.NaN).ToString(),
-        logic.GetMedian(columnIndex).ToString(),
-        logic.GetAverage(columnIndex).ToString(),
-        logic.GetStandardDeviation(columnIndex).ToString(),
-        logic.GetVariance(columnIndex).ToString(),
-        logic.GetOneQuarterPercentile(columnIndex).ToString(),
-        logic.GetThreeQuarterPercentile(columnIndex).ToString(),
-        logic.GetMostCommonValue<double>(columnIndex,double.NaN).ToString(),
-        logic.GetDifferentValuesCount<double>(columnIndex).ToString()
+        logic.GetColumnTypeAsString(statIdx),
+        logic.GetMissingValueCount(statIdx).ToString(),
+        logic.GetMin<double>(statIdx, double.NaN).ToString(),
+        logic.GetMax<double>(statIdx, double.NaN).ToString(),
+        logic.GetMedian(statIdx).ToString(),
+        logic.GetAverage(statIdx).ToString(),
+        logic.GetStandardDeviation(statIdx).ToString(),
+        logic.GetVariance(statIdx).ToString(),
+        logic.GetOneQuarterPercentile(statIdx).ToString(),
+        logic.GetThreeQuarterPercentile(statIdx).ToString(),
+        logic.GetMostCommonValue<double>(statIdx, double.NaN).ToString(),
+        logic.GetDifferentValuesCount<double>(statIdx).ToString()
       };
     }
 
-    private List<string> GetStringColumns(int columnIndex) {
+    private List<string> GetStringColumns(int statIdx) {
       var logic = Content.StatisticsLogic;
       return new List<string> {
-        logic.GetColumnTypeAsString(columnIndex),
-        logic.GetMissingValueCount(columnIndex).ToString(),
+        logic.GetColumnTypeAsString(statIdx),
+        logic.GetMissingValueCount(statIdx).ToString(),
         "", //min
         "", //max
@@ -172,55 +187,89 @@
         "", //quarter percentile
         "", //three quarter percentile
-        logic.GetMostCommonValue<string>(columnIndex,string.Empty) ?? "",
-        logic.GetDifferentValuesCount<string>(columnIndex).ToString()
+        logic.GetMostCommonValue<string>(statIdx,string.Empty) ?? "",
+        logic.GetDifferentValuesCount<string>(statIdx).ToString()
       };
     }
 
-    private List<string> GetDateTimeColumns(int columnIndex) {
+    private List<string> GetDateTimeColumns(int statIdx) {
       var logic = Content.StatisticsLogic;
       return new List<string> {
-        logic.GetColumnTypeAsString(columnIndex),
-        logic.GetMissingValueCount(columnIndex).ToString(),
-        logic.GetMin<DateTime>(columnIndex,DateTime.MinValue).ToString(),
-        logic.GetMax<DateTime>(columnIndex,DateTime.MinValue).ToString(),
-        logic.GetMedianDateTime(columnIndex).ToString(),
-        logic.GetAverageDateTime(columnIndex).ToString(),
-        logic.GetStandardDeviation(columnIndex).ToString(),
-        logic.GetVariance(columnIndex).ToString(), //variance
-        logic.GetOneQuarterPercentile(columnIndex).ToString(),
-        logic.GetThreeQuarterPercentile(columnIndex).ToString(),
-        logic.GetMostCommonValue<DateTime>(columnIndex,DateTime.MinValue).ToString(),
-        logic.GetDifferentValuesCount<DateTime>(columnIndex).ToString()
+        logic.GetColumnTypeAsString(statIdx),
+        logic.GetMissingValueCount(statIdx).ToString(),
+        logic.GetMin<DateTime>(statIdx, DateTime.MinValue).ToString(),
+        logic.GetMax<DateTime>(statIdx, DateTime.MinValue).ToString(),
+        logic.GetMedianDateTime(statIdx).ToString(),
+        logic.GetAverageDateTime(statIdx).ToString(),
+        logic.GetStandardDeviation(statIdx).ToString(),
+        logic.GetVariance(statIdx).ToString(),
+        logic.GetOneQuarterPercentile(statIdx).ToString(),
+        logic.GetThreeQuarterPercentile(statIdx).ToString(),
+        logic.GetMostCommonValue<DateTime>(statIdx, DateTime.MinValue).ToString(),
+        logic.GetDifferentValuesCount<DateTime>(statIdx).ToString()
       };
     }
 
-    private void dataGridView_CellValueNeeded(object sender, DataGridViewCellValueEventArgs e) {
-      if (Content != null && e.RowIndex < columnsRowsMatrix.Count && e.ColumnIndex < columnsRowsMatrix[0].Count) {
-        e.Value = columnsRowsMatrix[e.RowIndex][e.ColumnIndex];
-      }
-    }
-
     private void Content_Changed(object sender, DataPreprocessingChangedEventArgs e) {
-      switch (e.Type) {
-        case DataPreprocessingChangedEventType.DeleteColumn:
-          columnsRowsMatrix.RemoveAt(e.Column);
-          break;
-        case DataPreprocessingChangedEventType.AddColumn:
-          columnsRowsMatrix.Insert(e.Row, GetList(e.Column));
-          dataGridView.RowCount++;
-          break;
-        case DataPreprocessingChangedEventType.ChangeItem:
-          columnsRowsMatrix[e.Column] = GetList(e.Column);
-          break;
-        case DataPreprocessingChangedEventType.DeleteRow:
-        case DataPreprocessingChangedEventType.AddRow:
-        default:
-          for (int i = 0; i < columnsRowsMatrix.Count; ++i) {
-            columnsRowsMatrix[i] = GetList(e.Column);
-          }
-          break;
-      }
-      dataGridView.Refresh();
-    }
+      UpdateData();
+    }
+
+    #region Show/Hide Variables
+    private void checkInputsTargetButton_Click(object sender, EventArgs e) {
+      var grid = stringMatrixView.DataGridView;
+      var list = horizontal ? grid.Columns : grid.Rows as IList;
+      var variableNames = Content.PreprocessingData.VariableNames.ToList();
+      int idx = 0;
+      foreach (DataGridViewBand band in list) {
+        var variable = variableNames[idx++];
+        bool isInputTarget = Content.PreprocessingData.InputVariables.Contains(variable)
+                             || Content.PreprocessingData.TargetVariable == variable;
+        band.Visible = isInputTarget;
+        if (horizontal)
+          stringMatrixView.UpdateColumnHeaders();
+        else
+          stringMatrixView.UpdateRowHeaders();
+      }
+
+    }
+    private void checkAllButton_Click(object sender, EventArgs e) {
+      var grid = stringMatrixView.DataGridView;
+      var list = horizontal ? grid.Columns : grid.Rows as IList;
+      foreach (DataGridViewBand band in list) {
+        band.Visible = true;
+      }
+      if (horizontal)
+        stringMatrixView.UpdateColumnHeaders();
+      else
+        stringMatrixView.UpdateRowHeaders();
+    }
+    private void uncheckAllButton_Click(object sender, EventArgs e) {
+      var grid = stringMatrixView.DataGridView;
+      var list = horizontal ? grid.Columns : grid.Rows as IList;
+      foreach (DataGridViewBand band in list) {
+        band.Visible = false;
+      }
+    }
+    #endregion
+
+    #region Orientation
+    private void horizontalRadioButton_CheckedChanged(object sender, EventArgs e) {
+      var grid = stringMatrixView.DataGridView;
+      var oldVisibility = new Dictionary<string, bool>();
+      var variableNames = Content.PreprocessingData.VariableNames.ToList();
+      if (stringMatrixView.Content != null) {
+        var list = horizontal ? grid.Columns : grid.Rows as IList;
+        int idx = 0;
+        foreach (DataGridViewBand band in list) {
+          var variable = variableNames[idx++];
+          oldVisibility.Add(variable, band.Visible);
+        }
+      }
+      horizontal = horizontalRadioButton.Checked;
+      UpdateData(oldVisibility);
+    }
+    private void verticalRadioButton_CheckedChanged(object sender, EventArgs e) {
+      // everything is handled in horizontalRadioButton_CheckedChanged 
+    }
+    #endregion
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 15242)
@@ -28,9 +28,7 @@
 
 namespace HeuristicLab.DataPreprocessing.Views {
-
   [View("Transformation View")]
   [Content(typeof(TransformationContent), true)]
   public partial class TransformationView : AsynchronousContentView {
-
     public new TransformationContent Content {
       get { return (TransformationContent)base.Content; }
@@ -52,14 +50,8 @@
     }
 
-    /// <summary>
-    /// Adds eventhandlers to the current instance.
-    /// </summary>
     protected override void RegisterContentEvents() {
       Content.FilterLogic.FilterChanged += FilterLogic_FilterChanged;
     }
 
-    /// <summary>
-    /// Removes the eventhandlers from the current instance.
-    /// </summary>
     protected override void DeregisterContentEvents() {
       Content.FilterLogic.FilterChanged -= FilterLogic_FilterChanged;
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/Utils/VerticalLabel.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/Utils/VerticalLabel.cs	(revision 15242)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/Utils/VerticalLabel.cs	(revision 15242)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using System.Windows.Forms;
+
+namespace HeuristicLab.DataPreprocessing.Views {
+  public class VerticalLabel : Label {
+    protected override void OnPaint(PaintEventArgs e) {
+      Brush b = new SolidBrush(ForeColor);
+      var stringFormat = new StringFormat(StringFormatFlags.DirectionVertical);
+
+      var textSize = e.Graphics.MeasureString(Text, Font, PointF.Empty, stringFormat);
+      e.Graphics.TranslateTransform(Width / 2 + textSize.Width / 2, Height / 2 + textSize.Height / 2);
+      e.Graphics.RotateTransform(180);
+
+      e.Graphics.DrawString(Text, Font, b, PointF.Empty, stringFormat);
+    }
+  }
+}
+
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.Designer.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.Designer.cs	(revision 15242)
@@ -53,49 +53,12 @@
       this.SuspendLayout();
       // 
-      // splitContainer
-      // 
-      this.splitContainer.Size = new System.Drawing.Size(526, 364);
-      // 
-      // itemsGroupBox
-      // 
-      this.itemsGroupBox.Size = new System.Drawing.Size(532, 383);
-      // 
       // itemsListView
       // 
-      this.itemsListView.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
       this.itemsListView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.itemsListView.Location = new System.Drawing.Point(0, 0);
-      this.itemsListView.Size = new System.Drawing.Size(200, 364);
-      // 
-      // detailsGroupBox
-      // 
-      this.detailsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
-      this.detailsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.detailsGroupBox.Location = new System.Drawing.Point(0, 0);
-      this.detailsGroupBox.Size = new System.Drawing.Size(322, 364);
-      // 
-      // addButton
-      // 
-      this.toolTip.SetToolTip(this.addButton, "Add");
-      this.addButton.Visible = false;
-      // 
-      // removeButton
-      // 
-      this.toolTip.SetToolTip(this.removeButton, "Remove");
-      this.removeButton.Visible = false;
-      // 
-      // moveUpButton
-      // 
-      this.toolTip.SetToolTip(this.moveUpButton, "Move Up");
-      this.moveUpButton.Visible = false;
-      // 
-      // moveDownButton
-      // 
-      this.toolTip.SetToolTip(this.moveDownButton, "Move Down");
-      this.moveDownButton.Visible = false;
       // 
       // viewHost
       // 
-      this.viewHost.Size = new System.Drawing.Size(310, 339);
+      this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.viewHost.ViewsLabelVisible = false;
       // 
       // showDetailsCheckBox
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs	(revision 15242)
@@ -21,5 +21,4 @@
 
 using System;
-using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Core.Views;
@@ -30,8 +29,12 @@
   [Content(typeof(IItemList<IViewShortcut>), true)]
   public partial class ViewShortcutListView : ItemListView<IViewShortcut> {
-
     public ViewShortcutListView() {
       InitializeComponent();
-      itemsGroupBox.Text = "View Shortcuts";
+      Controls.Clear();
+      Controls.Add(splitContainer);
+      splitContainer.Panel1.Controls.Clear();
+      splitContainer.Panel1.Controls.Add(itemsListView);
+      splitContainer.Panel2.Controls.Clear();
+      splitContainer.Panel2.Controls.Add(viewHost);
     }
 
@@ -42,12 +45,13 @@
         IViewShortcut item = itemsListView.SelectedItems[0].Tag as IViewShortcut;
         if (item != null) {
-
-          if (item is IViewChartShortcut)
-            item = (IViewChartShortcut)item.Clone(new Cloner());
-
-          IContentView view = MainFormManager.MainForm.ShowContent(item);
-          if (view != null) {
-            view.ReadOnly = ReadOnly;
-            view.Locked = Locked;
+          try {
+            item = (IViewShortcut)item.Clone();
+            var view = MainFormManager.MainForm.ShowContent(item);
+            if (view != null) {
+              view.ReadOnly = ReadOnly;
+              view.Locked = Locked;
+            }
+          } catch (NullReferenceException) {
+            // cloning for preprocessing not done properly yet
           }
         }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 15242)
@@ -27,11 +27,11 @@
 namespace HeuristicLab.DataPreprocessing {
   [Item("Feature Correlation Matrix", "Represents the feature correlation matrix.")]
-  public class CorrelationMatrixContent : Item, IViewChartShortcut {
+  public class CorrelationMatrixContent : Item, IViewShortcut {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Gradient; }
     }
 
-    private PreprocessingContext Context { get; set; }
-    private ITransactionalPreprocessingData PreprocessingData {
+    public PreprocessingContext Context { get; private set; }
+    public ITransactionalPreprocessingData PreprocessingData {
       get { return Context.Data; }
     }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs	(revision 15242)
@@ -1,15 +1,35 @@
-﻿using System.Drawing;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 
 namespace HeuristicLab.DataPreprocessing {
-  [Item("DataCompletenessChart", "Represents a datacompleteness chart.")]
+  [Item("Data Completeness Chart", "Represents a datacompleteness chart.")]
 
-  public class DataCompletenessChartContent : Item, IViewChartShortcut {
+  public class DataCompletenessChartContent : Item, IViewShortcut {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.EditBrightnessContrast; }
     }
 
-    //public DataGridLogic DataGridLogic { get; private set; }
     public SearchLogic SearchLogic { get; private set; }
 
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs	(revision 15242)
@@ -30,12 +30,11 @@
 namespace HeuristicLab.DataPreprocessing {
 
-  [Item("DataGrid", "Represents a data grid.")]
+  [Item("Data Grid", "Represents a data grid.")]
   public class DataGridContent : Item, IStringConvertibleMatrix, IViewShortcut {
-
-    public ITransactionalPreprocessingData PreProcessingData { get; private set; }
-
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Table; }
     }
+
+    public ITransactionalPreprocessingData PreProcessingData { get; private set; }
 
     public ManipulationLogic ManipulationLogic { get; private set; }
@@ -43,46 +42,26 @@
 
     public int Rows {
-      get {
-        return PreProcessingData.Rows;
-      }
-      set {
-        //does nothing
-      }
+      get { return PreProcessingData.Rows; }
+      set { }
     }
 
     public int Columns {
-      get {
-        return PreProcessingData.Columns;
-      }
-      set {
-        //does nothing
-      }
+      get { return PreProcessingData.Columns; }
+      set { }
     }
 
     public IEnumerable<string> ColumnNames {
-      get {
-        return PreProcessingData.VariableNames;
-      }
-      set {
-
-      }
+      get { return PreProcessingData.VariableNames; }
+      set { }
     }
 
     public IEnumerable<string> RowNames {
-      get {
-        return Enumerable.Range(1, Rows).Select(n => n.ToString());
-      }
-      set {
-        throw new NotSupportedException();
-      }
+      get { return Enumerable.Range(1, Rows).Select(n => n.ToString()); }
+      set { throw new NotSupportedException(); }
     }
 
     public bool SortableView {
-      get {
-        return true;
-      }
-      set {
-        throw new NotSupportedException();
-      }
+      get { return true; }
+      set { throw new NotSupportedException(); }
     }
 
@@ -91,10 +70,8 @@
     }
 
-
     public IDictionary<int, IList<int>> Selection {
       get { return PreProcessingData.Selection; }
       set { PreProcessingData.Selection = value; }
     }
-
 
     public DataGridContent(ITransactionalPreprocessingData preProcessingData, ManipulationLogic theManipulationLogic, FilterLogic theFilterLogic) {
@@ -137,5 +114,4 @@
     }
 
-
     #region unused stuff/not implemented but necessary due to IStringConvertibleMatrix
 #pragma warning disable 0067
@@ -154,8 +130,6 @@
     public event EventHandler<EventArgs<int, int>> ItemChanged;
     public event EventHandler Reset;
-
 #pragma warning restore 0067
     #endregion
-
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/FilterContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/FilterContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/FilterContent.cs	(revision 15242)
@@ -28,33 +28,17 @@
   [Item("Filter", "Represents the filter grid.")]
   public class FilterContent : Item, IViewShortcut {
-
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Filter; }
     }
 
-    private ICheckedItemCollection<IFilter> filters = new CheckedItemCollection<IFilter>();
-
     public FilterLogic FilterLogic { get; private set; }
 
-    public ICheckedItemCollection<IFilter> Filters {
-      get {
-        return this.filters;
-      }
-      set {
-        this.filters = value;
-      }
-    }
+    public ICheckedItemCollection<IFilter> Filters { get; private set; }
 
-    private bool isAndCombination = true;
-    public bool IsAndCombination {
-      get {
-        return this.isAndCombination;
-      }
-      set {
-        this.isAndCombination = value;
-      }
-    }
+    public bool IsAndCombination { get; set; }
 
     public FilterContent(FilterLogic filterLogic) {
+      Filters = new CheckedItemCollection<IFilter>();
+      IsAndCombination = true;
       FilterLogic = filterLogic;
     }
